#!/bin/sh

# OS configuration setup (SPC-1 Users' Guide)
cat /proc/sys/fs/epoll/max_user_watches >> /proc/sys/fs/aio-max-nr
source ulimit -n 1000
source ulimit -s unlimited

echo 3 > /proc/sys/vm/drop_caches

# systemctl stop irqbalance
# systemctl disable irqbalance

# CPU Governor setup
for i in `seq 0 35`
do
	echo performance > /sys/devices/system/cpu/cpu$i/cpufreq/scaling_governor
done

# Queue setup 
devs=$(ls /sys/block/nvme*n1/device/model | awk -F '/' '{print $4}')

for dev in $devs;
do
	#devices configuration setup
	echo 64 > /sys/block/$dev/queue/nr_requests #128 is the max size
	echo 'none' > /sys/block/$dev/queue/scheduler
 	echo 2 > /sys/block/$dev/queue/nomerges
	echo 0 > /sys/block/$dev/queue/add_random
 	echo 1 > /sys/block/$dev/queue/rq_affinity
	
	cat /sys/block/$dev/queue/nr_requests
	cat /sys/block/$dev/queue/scheduler
 	cat /sys/block/$dev/queue/nomerges
	cat /sys/block/$dev/queue/add_random
 	cat /sys/block/$dev/queue/rq_affinity
done
