#!/bin/sh
# NVMe NameSpace Overprovisioning Function

#ns_size=15000000000 # Full
ns_size=11000000000	#25%

nvme_over_provision () {
	for num in $(seq 0 7)
	do
		echo OverProvision 22% /dev/nvme${num}n1
		nvme detach-ns /dev/nvme${num} -namespace-id=1 -controllers=0
		nvme delete-ns /dev/nvme${num} -namespace-id=1
		nvme create-ns /dev/nvme${num} -nsze $ns_size -ncap $ns_size -flbas 0 -dps 0 -nmic 0
		nvme attach-ns /dev/nvme${num} -namespace-id=1 -controllers=0
#		nvme reset /dev/nvme${num}

		echo Format 512 sector /dev/nvme${num}n1
		nvme format -l0 -f /dev/nvme${num}n1 
#		echo Format Secure Erase /dev/nvme${num}n1
#		nvme format -s0 -f /dev/nvme${num}n1 
	done
}

# Linux RAID 1 Create Function
mkraid () {
	yes | mdadm --create --verbose /dev/md0 --level=1 --raid-devices 2 \
		/dev/nvme0n1 /dev/nvme1n1
	yes | mdadm --create --verbose /dev/md1 --level=1 --raid-devices 2 \
		/dev/nvme2n1 /dev/nvme3n1
	yes | mdadm --create --verbose /dev/md2 --level=1 --raid-devices 2 \
		/dev/nvme4n1 /dev/nvme5n1
	yes | mdadm --create --verbose /dev/md3 --level=1 --raid-devices 2 \
		/dev/nvme6n1 /dev/nvme7n1

}

clean () {
	vgremove spc
	mdadm --stop /dev/md0
	mdadm --stop /dev/md1
	mdadm --stop /dev/md2
	mdadm --stop /dev/md3
}

# Main Start

#clean
nvme_over_provision
mkraid
