#!/bin/bash
# Load nvmet kernel driver Function

ip_addr1="10.10.10.10"
ip_addr2="10.10.11.10"

mode=rdma

load_nvmet () {
	modprobe nvmet
	modprobe nvmet_${mode}
	#modprobe nvmet_${mode} offload_mem_start=0x1680000000 offload_mem_size=2048 offload_buffer_size=512
}

# Bind nvmet target Function
bind_md_nvmet1 () {
	mkdir -p /sys/kernel/config/nvmet/ports/1
	echo "ipv4" > /sys/kernel/config/nvmet/ports/1/addr_adrfam
	echo $mode > /sys/kernel/config/nvmet/ports/1/addr_trtype
	echo $ip_addr1 > /sys/kernel/config/nvmet/ports/1/addr_traddr
	echo 4420 > /sys/kernel/config/nvmet/ports/1/addr_trsvcid
	for vol in `seq 0 3`
	do
		echo add /dev/md${vol} to nvme-${mode} target
		mkdir -p /sys/kernel/config/nvmet/subsystems/spc-${vol}
		echo 1 > /sys/kernel/config/nvmet/subsystems/spc-${vol}/attr_allow_any_host
		mkdir -p /sys/kernel/config/nvmet/subsystems/spc-${vol}/namespaces/1
		echo -n /dev/md${vol} > \
			/sys/kernel/config/nvmet/subsystems/spc-${vol}/namespaces/1/device_path
		echo 1 > /sys/kernel/config/nvmet/subsystems/spc-${vol}/namespaces/1/enable
		ln -s /sys/kernel/config/nvmet/subsystems/spc-${vol} \
			/sys/kernel/config/nvmet/ports/1/subsystems
	done
}

bind_md_nvmet2 () {
	mkdir -p /sys/kernel/config/nvmet/ports/2
	echo "ipv4" > /sys/kernel/config/nvmet/ports/2/addr_adrfam
	echo $mode > /sys/kernel/config/nvmet/ports/2/addr_trtype
	echo $ip_addr2 > /sys/kernel/config/nvmet/ports/2/addr_traddr
	echo 4420 > /sys/kernel/config/nvmet/ports/2/addr_trsvcid
	for vol in `seq 0 3`
	do
		ln -s /sys/kernel/config/nvmet/subsystems/spc-${vol} \
			/sys/kernel/config/nvmet/ports/2/subsystems
	done
}

# Main Start
load_nvmet
bind_md_nvmet1
bind_md_nvmet2
