#!/bin/sh
# get_tsc_config.sh $LOG_PATH $LOG_FILE_NAME

target_ip="10.100.250.113"
host_ip="10.100.250.73 10.100.250.124"
#host_ip="10.100.250.73"
sys_log=$1"/"$2

echo "Start Time: `date "+%Y-%m-%d %H:%M:%S.%N"`" > $sys_log

echo "########################################################################" >> $sys_log
echo "#                  SPC-1 TSC Environment Check Script                  #" >> $sys_log
echo "#                      Created by Gluesys Co.,Ltd.                     #" >> $sys_log
echo "########################################################################" >> $sys_log

echo "" >> $sys_log
echo "" >> $sys_log
echo "" >> $sys_log

for ip in $host_ip;
do
        echo "##### Get Host $ip Information. #####" >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	dmidecode -t system >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	cat /etc/os-release >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	uname -r >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	lscpu >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	lshw -class processor >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	cat /proc/meminfo >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	lshw -class memory >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	lspci | grep "Mellanox" >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	lsblk -b >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	fdisk -l >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	pvs --units G >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	vgs --units G >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	lvs --units G -v --segment >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log

	echo "Get Host-Disk parameter." >> $sys_log


	devs=$(lsblk | grep 'nvme*' | awk -F ' ' '{print $1}')	# IB (Ethernet)

	echo =====================$ip===================== >> $sys_log

	for dev in $devs;
	do
		echo +++++++++++++++/dev/$dev+++++++++++++++ >> $sys_log
		#devices configuration setup
		echo -n 'nr_requests : ' >> $sys_log
		ssh root@$ip cat /sys/block/$dev/queue/nr_requests >> $sys_log
		echo -n 'scheduler : ' >> $sys_log
		ssh root@$ip cat /sys/block/$dev/queue/scheduler >> $sys_log
		echo -n 'nomerges : ' >> $sys_log
		ssh root@$ip cat /sys/block/$dev/queue/nomerges >> $sys_log
		echo -n 'add_random : ' >> $sys_log
		ssh root@$ip cat /sys/block/$dev/queue/add_random >> $sys_log
		echo -n 'rq_affinity : ' >> $sys_log
		ssh root@$ip cat /sys/block/$dev/queue/rq_affinity >> $sys_log

	done
	#OS configuration setup
	echo '+++++++++++++++system parameter+++++++++++++++' >> $sys_log
	echo -n 'aio-max-nr : '	>> $sys_log
	echo '----------------------------------------------' >> $sys_log
	ssh root@$ip cat /proc/sys/fs/aio-max-nr >> $sys_log
	echo 'ulimit -a' >> $sys_log
	ssh root@$ip ulimit -a >> $sys_log
	echo '----------------------------------------------' >> $sys_log
	echo 'ulimit -aH' >> $sys_log
	ssh root@$ip ulimit -aH >> $sys_log
	echo "" >> $sys_log
	echo "" >> $sys_log
	echo "" >> $sys_log
done

for ip in $target_ip;
do
	echo "##### Get Storage $ip Information. #####" >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	ssh root@$target_ip lscpu >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	ssh root@$target_ip lshw -class processor >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	ssh root@$target_ip cat /proc/meminfo >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	ssh root@$target_ip lshw -class memory >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	ssh root@$target_ip 'lspci | grep "Mellanox"' >> $sys_log
	echo -e "++++++++++++++++++++++++++++++++++++\n" >> $sys_log
	ssh root@$target_ip nvme list >> $sys_log
	
	echo "Get Storage-Disk information.(smartctl)" >> $sys_log


	echo ====================$ip================= >> $sys_log
	devs=$(ssh root@$ip 'ls /dev/nvme*n1')	# IB(Ethernet)
	for dev in $devs
	do
		echo +++++++++++++++++++++$dev++++++++++++++++++ >> $sys_log
        	ssh root@$ip smartctl -a $dev >> $sys_log
	done

	echo "Get Storage-RAID information." >> $sys_log

	for ip in $target_ip;
	do
		echo ====================$ip================= >> $sys_log
		ssh root@$ip 'mdadm --detail /dev/md?' >> $sys_log
	done

	echo "" >> $sys_log
	echo "" >> $sys_log
	echo "" >> $sys_log

done


echo "End Time: `date "+%Y-%m-%d %H:%M:%S.%N"`" >> $sys_log
